// Persistence Of Vision raytracer version 3.0 MPOV/isosurface patch
// sample file. By D.Skarda.
//              Modified by R. Suzuki.

#declare BranchRatio= 3/4
#declare Red_Col=0
#declare Green_Col=0
#declare Red_Freq=1
#declare Green_Freq=1.46444444

#macro BeginTree(float lenght, float bwidth, float depth)
  #if (depth < 0)
//    cylinder {
//      <0,0,0>, <0,lenght,0> bwidth
#declare Red_Col= Green_Col+1.0
#declare Green_Col= Green_Col+1.0
   isosurface{ function "rounded_box", <lenght/6>
               box <-lenght/2, -lenght/2, -lenght/2> <lenght/2, lenght/2, lenght/2>
     finish {phong 0.3}
     finish {ambient .5}
     pigment {color red 0.85-sin(Red_Col*Red_Freq)*0.15 green 0.72-sin(Green_Col*Green_Freq)*0.1 blue 0.2}

  #else
   union {
    union {
     #BeginTree( lenght*BranchRatio, bwidth*BranchRatio, depth-1)
       rotate < 45,  0,  0>
     #EndTree()
     #BeginTree( lenght*BranchRatio, bwidth*BranchRatio, depth-1)
       rotate <-45,  0,  0>
       rotate <  0,-60,  0>
     #EndTree()
     #BeginTree( lenght*BranchRatio, bwidth*BranchRatio, depth-1)
       rotate <-45,  0,  0>
       rotate <  0, 60,  0>
     #EndTree()
     translate y*lenght
    }
    #BeginTree(lenght, bwidth, -1)
    #EndTree()
  #end
#end_macro

#macro EndTree()
 }
#end_macro


#BeginTree( 3, .125, 5 )
//  finish {phong 0.2}
//  finish {ambient .4}
//  pigment {color red 0.1647 green 0.8 blue 0.164706}
#EndTree()

camera {
 location <10,12,10>
 look_at  <0,3.5,0>
}

light_source {
  <0, 40, 20>
  color rgb<1,1,1>
}
light_source {
  <0, 40, -30>
  color rgb<1,1,1>
}

plane {
 <0,1,0>,0
// pigment {color red 0.74902 green 0.847059 blue 0.847059}
 pigment {color red 0.54902 green 0.647059 blue 0.647059}
 finish {ambient .4}
}
