// Persistence Of Vision raytracer version 3.0 (isosurface)
// sample file.
// By R.Suzuki
// This image contains an example of 'isosurface'.

    /* helix                                     *
     *   p[0] : number of helix                  *
     *   p[1] : frequency                        *
     *   p[2] : minor radius                     *
     *   p[3] : major radius                     *
     *   p[4] : shape parameter                  *
     *   p[5] : cross section                    *
     *             p[5] = 1:  circle             *
     *                  = 2:  diamond            *
     *                  < 1:  rectangle(rounded) *
     *   p[6] : rotation angle for p[5]<1        */


#include "isocom.inc"

isosurface
{
     function    {"helix1", <2, 4, 0.1, 1.5, 1, 1, 0>}
     bounded_by {box {<-1.7, -5, -1.7>, <1.7, 5, 1.7>}}
     scale 2.2
     texture{ComYw}
     no_shadow
}

isosurface
{
     function    {"helix2", <1, -3, 1.15, 0.15, 1, 1, 0>}
     bounded_by {box {<-1.3, -4, -1.3>, <1.3, 4, 1.3>}}
     scale 1.2
     texture{ComGreen}
     translate <-7,-2,0>
     no_shadow
}


  isosurface
  {
     function  {"helix1", <1, -1, 0.8, 1.5, 1.0, 0.5, 15>}
     bounded_by {box {<-2.5, -12, -2.5>, <2.5, 12, 2.5>}}
     eval
     texture {ComBl}
     no_shadow
  }


  isosurface
  {
     function  {"helix1", <1, 3, 0.9, 1.7, 1.0, 0.2, 45>}
     bounded_by {box {<-3.0, -7, -3.0>, <3.0, 7, 3.0>}}
     eval
     texture {ComRed}
     scale <0.5, 1, 0.5>
     translate <7,2,0>
     no_shadow
  }
