# This is a make file of dynamic link functions for UNIX machines 
# which support shared libraries.
# set ODIR to the location where you want the object files placed.
ODIR=.

# set SRCDIR to the location where the main POV-Ray source is located.
SRCDIR=..

CFLAGS      = -O2 -ansi -DUNIX -I$(SRCDIR) -I.

# Your compiler
CC          = gcc
#CC          = cc

i_nfuncDEP                = $(SRCDIR)/i_nfunc.c \
                          $(SRCDIR)/isosrf.h    \
                          $(SRCDIR)/frame.h    \
                          config.h  \
                          $(SRCDIR)/isofunc.h   

i_dat3dDEP                = $(SRCDIR)/i_dat3d.c \
                          $(SRCDIR)/isosrf.h    \
                          $(SRCDIR)/frame.h    \
                          config.h \
                          $(SRCDIR)/isofunc.h   

all: i_nfunc.so i_dat3d.so

i_nfunc.so: $(i_nfuncDEP)
	$(CC) $(CFLAGS) -o i_nfunc.so -shared -fPIC $(SRCDIR)/i_nfunc.c


i_dat3d.so: $(i_dat3dDEP)
	$(CC) $(CFLAGS) -o i_dat3d.so -shared -fPIC $(SRCDIR)/i_dat3d.c
