// Persistence Of Vision raytracer version 3.0 isosurface patch
// sample file. By R.Suzuki.
// This image contains an example of 'isosurface'.

#include "colors.inc"
#include "textures.inc"

#declare B_Agate =
 pigment
  {agate
   color_map
    {[0.0, 0.5   color <  1,   1,   1>  color <0.9, 0.7, 0.6>]
     [0.5, 0.6   color <0.9, 0.7, 0.6>  color <0.9, 0.7, 0.4>]
     [0.6, 1.001 color <0.9, 0.7, 0.4>  color <0.7, 0.4, 0.2>]
    }
  }


camera {
   location <24, 25, -45>
   direction <0, 0,  4.0>
   look_at <0,0,0>
}

light_source {<150, 400, -120> color White}
light_source {<350, 200, -120> color White}

isosurface
{
     function   {"func_12", <6., 9, 3, 0, 1.0, 1.2, 0.13, -6, 0.1,-64>,  library "i_nfunc" }
     bounded_by{ box {<-9, -3, -9>, <9, 3, 9>}}
     eval
     accuracy     0.01
     pigment {color red 0.05 green 0.05 blue 0.1}
     finish {reflection 0.6     phong 0.8}
}

isosurface
{
     function  {"func_12", <6., -30, 5, 0, 0.12, 2.75, 0.03, -6, 0.1,-64>,  library "i_nfunc"}
     bounded_by{ box {<-10, -4, -10>, <10, 4, 10>}}
     accuracy     0.01
     eval <1.0, 1.3, 0.997>
     pigment {B_Agate}
     finish {phong 1.0}
}

plane { <0, 1, 0>, 0
   pigment {White_Marble}
   scale 70
   translate <0,-40,0>
   no_shadow
}

background {color DarkSlateGray}

