// Persistence Of Vision raytracer version 2.2 equpotsurface patch
// sample file. By R.Suzuki.
// This image contains an example of 'equpotsurface'.

#include "colors.inc"
#include "textures.inc"

camera {
   location <24, 30, -45>
   direction <0, 0,  5.0>
   look_at <0,0.5,0>
}

light_source {<150, 400, -120> color White}
light_source {<350, 200, -120> color White}

object {
union{
  isosurface
  {
     function   {"func_13", <6.>,  library "i_nfunc"}
     bounded_by{ box {<-6.5, -3.5, -6.5>, <6.5, 3.5, 6.5>}}
     max_gradient 1.5
     texture{
        pigment { color red 0.90 green 0.6 blue 0.6}
        finish {phong 0.5}
     }
     no_shadow
     rotate <0, 90, 0>
   }
   isosurface
  {
     function    {"func_13", <6.>,  library "i_nfunc"}
     bounded_by{ box {<-6.5, -3.5, -6.5>, <6.5, 3.5, 6.5>}}
     max_gradient 1.5
     texture{
        pigment { color red 0.6 green 0.6 blue 0.90}
        finish {phong 0.5}
     }
   no_shadow
   rotate <0, -90,0>
  }
}
rotate y*288
}
background {color DarkSlateGray}

