// Persistence Of Vision raytracer version 3.0 isosurface patch
// sample file. By R.Suzuki.

#include "colors.inc"
#include "textures.inc"

global_settings { max_trace_level 11 }

camera {
   location <30, 10, -45>
   direction <0, 0,  4.5>
   look_at <0,0,0>
}

light_source {<120, 300, -120> color Gray80}
light_source {<300, 200, -120> color Gray70}
light_source {<200, 200, -300> color Gray60}

isosurface
  {
     function  {"func_2", <16, 0.01, 6.0, 3., 0.>,  library "i_nfunc"}
     bounded_by{ box {<-5.5, -5.5, -5.5>, <5.5, 5.5, 5.5>}}
     max_gradient 5.0

     texture{
        pigment { color red 0.8 green 0.8 blue 0.95 filter 1.0}
        finish {phong 0.8}
        finish {
          refraction 1
          ior 1.5
        }
     }
   rotate <0,-10,0>
}

plane {<0, 1, 0>, 0
   pigment {White_Wood}
   scale 1.5
   translate <0,-5.52,0>
   no_shadow
}

plane {<1, 0, 0>,0
   pigment{Brown_Agate}
   scale 3
   translate <-12,0,0>
   no_shadow
}

plane {<0, 0, -1>, 0
   pigment {White_Marble}
   scale 2
   translate <0,0,20>
   no_shadow
}

background {color Gray50}
